/* SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause) */

/* THIS FILE IS AUTOGENERATED BY BPFTOOL! */
#ifndef __FENTRY_UNSUPP_FUNC_BPF_SKEL_H__
#define __FENTRY_UNSUPP_FUNC_BPF_SKEL_H__

#include <errno.h>
#include <stdlib.h>
#include <bpf/libbpf.h>

#define BPF_SKEL_SUPPORTS_MAP_AUTO_ATTACH 1

struct fentry_unsupp_func_bpf {
	struct bpf_object_skeleton *skeleton;
	struct bpf_object *obj;
	struct {
		struct bpf_program *fentry_handler;
	} progs;
	struct {
		struct bpf_link *fentry_handler;
	} links;

#ifdef __cplusplus
	static inline struct fentry_unsupp_func_bpf *open(const struct bpf_object_open_opts *opts = nullptr);
	static inline struct fentry_unsupp_func_bpf *open_and_load();
	static inline int load(struct fentry_unsupp_func_bpf *skel);
	static inline int attach(struct fentry_unsupp_func_bpf *skel);
	static inline void detach(struct fentry_unsupp_func_bpf *skel);
	static inline void destroy(struct fentry_unsupp_func_bpf *skel);
	static inline const void *elf_bytes(size_t *sz);
#endif /* __cplusplus */
};

static void
fentry_unsupp_func_bpf__destroy(struct fentry_unsupp_func_bpf *obj)
{
	if (!obj)
		return;
	if (obj->skeleton)
		bpf_object__destroy_skeleton(obj->skeleton);
	free(obj);
}

static inline int
fentry_unsupp_func_bpf__create_skeleton(struct fentry_unsupp_func_bpf *obj);

static inline struct fentry_unsupp_func_bpf *
fentry_unsupp_func_bpf__open_opts(const struct bpf_object_open_opts *opts)
{
	struct fentry_unsupp_func_bpf *obj;
	int err;

	obj = (struct fentry_unsupp_func_bpf *)calloc(1, sizeof(*obj));
	if (!obj) {
		errno = ENOMEM;
		return NULL;
	}

	err = fentry_unsupp_func_bpf__create_skeleton(obj);
	if (err)
		goto err_out;

	err = bpf_object__open_skeleton(obj->skeleton, opts);
	if (err)
		goto err_out;

	return obj;
err_out:
	fentry_unsupp_func_bpf__destroy(obj);
	errno = -err;
	return NULL;
}

static inline struct fentry_unsupp_func_bpf *
fentry_unsupp_func_bpf__open(void)
{
	return fentry_unsupp_func_bpf__open_opts(NULL);
}

static inline int
fentry_unsupp_func_bpf__load(struct fentry_unsupp_func_bpf *obj)
{
	return bpf_object__load_skeleton(obj->skeleton);
}

static inline struct fentry_unsupp_func_bpf *
fentry_unsupp_func_bpf__open_and_load(void)
{
	struct fentry_unsupp_func_bpf *obj;
	int err;

	obj = fentry_unsupp_func_bpf__open();
	if (!obj)
		return NULL;
	err = fentry_unsupp_func_bpf__load(obj);
	if (err) {
		fentry_unsupp_func_bpf__destroy(obj);
		errno = -err;
		return NULL;
	}
	return obj;
}

static inline int
fentry_unsupp_func_bpf__attach(struct fentry_unsupp_func_bpf *obj)
{
	return bpf_object__attach_skeleton(obj->skeleton);
}

static inline void
fentry_unsupp_func_bpf__detach(struct fentry_unsupp_func_bpf *obj)
{
	bpf_object__detach_skeleton(obj->skeleton);
}

static inline const void *fentry_unsupp_func_bpf__elf_bytes(size_t *sz);

static inline int
fentry_unsupp_func_bpf__create_skeleton(struct fentry_unsupp_func_bpf *obj)
{
	struct bpf_object_skeleton *s;
	struct bpf_map_skeleton *map __attribute__((unused));
	int err;

	s = (struct bpf_object_skeleton *)calloc(1, sizeof(*s));
	if (!s)	{
		err = -ENOMEM;
		goto err;
	}

	s->sz = sizeof(*s);
	s->name = "fentry_unsupp_func_bpf";
	s->obj = &obj->obj;

	/* programs */
	s->prog_cnt = 1;
	s->prog_skel_sz = sizeof(*s->progs);
	s->progs = (struct bpf_prog_skeleton *)calloc(s->prog_cnt, s->prog_skel_sz);
	if (!s->progs) {
		err = -ENOMEM;
		goto err;
	}

	s->progs[0].name = "fentry_handler";
	s->progs[0].prog = &obj->progs.fentry_handler;
	s->progs[0].link = &obj->links.fentry_handler;

	s->data = fentry_unsupp_func_bpf__elf_bytes(&s->data_sz);

	obj->skeleton = s;
	return 0;
err:
	bpf_object__destroy_skeleton(s);
	return err;
}

static inline const void *fentry_unsupp_func_bpf__elf_bytes(size_t *sz)
{
	static const char data[] __attribute__((__aligned__(8))) = "\
\x7f\x45\x4c\x46\x02\x02\x01\0\0\0\0\0\0\0\0\0\0\x01\0\xf7\0\0\0\x01\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x03\x40\0\0\0\0\0\x40\0\0\0\0\0\x40\0\x07\0\
\x01\0\x2e\x73\x74\x72\x74\x61\x62\0\x2e\x73\x79\x6d\x74\x61\x62\0\x66\x65\x6e\
\x74\x72\x79\x2f\x62\x74\x66\x5f\x73\x74\x72\x75\x63\x74\x5f\x61\x63\x63\x65\
\x73\x73\0\x6c\x69\x63\x65\x6e\x73\x65\0\x66\x65\x6e\x74\x72\x79\x5f\x75\x6e\
\x73\x75\x70\x70\x5f\x66\x75\x6e\x63\x2e\x62\x70\x66\x2e\x63\0\x66\x65\x6e\x74\
\x72\x79\x5f\x68\x61\x6e\x64\x6c\x65\x72\0\x4c\x49\x43\x45\x4e\x53\x45\0\x2e\
\x42\x54\x46\0\x2e\x42\x54\x46\x2e\x65\x78\x74\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\x32\x04\0\xff\xf1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\x03\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x4b\x12\0\0\x03\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x10\0\0\0\x5a\x11\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x04\xb4\0\0\0\0\0\0\0\x95\0\0\0\0\0\0\0\x42\x53\x44\0\0\0\0\0\xeb\x9f\x01\0\0\
\0\0\x18\0\0\0\0\0\0\0\xac\0\0\0\xac\0\0\0\xe9\0\0\0\0\x02\0\0\0\0\0\0\x02\0\0\
\0\x01\x01\0\0\0\0\0\0\x08\0\0\0\x40\0\0\0\0\x0d\0\0\x01\0\0\0\x04\0\0\0\x14\0\
\0\0\x01\0\0\0\x18\x01\0\0\0\0\0\0\x04\x01\0\0\x20\0\0\0\x1c\x0c\0\0\x01\0\0\0\
\x03\0\0\0\x2b\x01\0\0\0\0\0\0\x01\x01\0\0\x08\0\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\
\x06\0\0\0\x08\0\0\0\x04\0\0\0\x30\x01\0\0\0\0\0\0\x04\0\0\0\x20\0\0\0\x44\x0e\
\0\0\0\0\0\0\x07\0\0\0\x01\0\0\0\xc8\x0f\0\0\x01\0\0\0\x04\0\0\0\x09\0\0\0\0\0\
\0\0\x04\0\x75\x6e\x73\x69\x67\x6e\x65\x64\x20\x6c\x6f\x6e\x67\x20\x6c\x6f\x6e\
\x67\0\x63\x74\x78\0\x69\x6e\x74\0\x66\x65\x6e\x74\x72\x79\x5f\x68\x61\x6e\x64\
\x6c\x65\x72\0\x63\x68\x61\x72\0\x5f\x5f\x41\x52\x52\x41\x59\x5f\x53\x49\x5a\
\x45\x5f\x54\x59\x50\x45\x5f\x5f\0\x4c\x49\x43\x45\x4e\x53\x45\0\x2f\x62\x75\
\x69\x6c\x64\x64\x69\x72\x2f\x62\x75\x69\x6c\x64\x2f\x42\x55\x49\x4c\x44\x2f\
\x72\x65\x74\x73\x6e\x6f\x6f\x70\x2d\x30\x2e\x31\x30\x2e\x31\x2d\x62\x75\x69\
\x6c\x64\x2f\x72\x65\x74\x73\x6e\x6f\x6f\x70\x2d\x30\x2e\x31\x30\x2e\x31\x2f\
\x73\x72\x63\x2f\x74\x65\x73\x74\x73\x2f\x66\x65\x6e\x74\x72\x79\x5f\x75\x6e\
\x73\x75\x70\x70\x5f\x66\x75\x6e\x63\x2e\x62\x70\x66\x2e\x63\0\x69\x6e\x74\x20\
\x42\x50\x46\x5f\x50\x52\x4f\x47\x28\x66\x65\x6e\x74\x72\x79\x5f\x68\x61\x6e\
\x64\x6c\x65\x72\x29\0\x6c\x69\x63\x65\x6e\x73\x65\0\x66\x65\x6e\x74\x72\x79\
\x2f\x62\x74\x66\x5f\x73\x74\x72\x75\x63\x74\x5f\x61\x63\x63\x65\x73\x73\0\0\0\
\0\xeb\x9f\x01\0\0\0\0\x20\0\0\0\0\0\0\0\x14\0\0\0\x14\0\0\0\x1c\0\0\0\x30\0\0\
\0\0\0\0\0\x08\0\0\0\xd0\0\0\0\x01\0\0\0\0\0\0\0\x05\0\0\0\x10\0\0\0\xd0\0\0\0\
\x01\0\0\0\0\0\0\0\x4c\0\0\0\xab\0\0\x24\x05\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\x03\0\0\0\0\0\0\0\x20\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\x40\0\0\0\0\0\0\0\x70\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\
\0\0\0\x09\0\0\0\x02\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xb0\0\0\0\0\
\0\0\0\x78\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\x18\0\0\0\x11\0\0\
\0\x01\0\0\0\0\0\0\0\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\x28\0\0\0\0\0\0\0\x10\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\x2a\0\0\0\x01\0\0\0\0\
\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\x38\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\x62\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x01\x40\0\0\0\0\0\0\x01\xad\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\x08\0\0\0\0\0\0\0\0\0\0\0\x67\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\x02\xf0\0\0\0\0\0\0\0\x50\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\
\0\0\0";

	*sz = sizeof(data) - 1;
	return (const void *)data;
}

#ifdef __cplusplus
struct fentry_unsupp_func_bpf *fentry_unsupp_func_bpf::open(const struct bpf_object_open_opts *opts) { return fentry_unsupp_func_bpf__open_opts(opts); }
struct fentry_unsupp_func_bpf *fentry_unsupp_func_bpf::open_and_load() { return fentry_unsupp_func_bpf__open_and_load(); }
int fentry_unsupp_func_bpf::load(struct fentry_unsupp_func_bpf *skel) { return fentry_unsupp_func_bpf__load(skel); }
int fentry_unsupp_func_bpf::attach(struct fentry_unsupp_func_bpf *skel) { return fentry_unsupp_func_bpf__attach(skel); }
void fentry_unsupp_func_bpf::detach(struct fentry_unsupp_func_bpf *skel) { fentry_unsupp_func_bpf__detach(skel); }
void fentry_unsupp_func_bpf::destroy(struct fentry_unsupp_func_bpf *skel) { fentry_unsupp_func_bpf__destroy(skel); }
const void *fentry_unsupp_func_bpf::elf_bytes(size_t *sz) { return fentry_unsupp_func_bpf__elf_bytes(sz); }
#endif /* __cplusplus */

__attribute__((unused)) static void
fentry_unsupp_func_bpf__assert(struct fentry_unsupp_func_bpf *s __attribute__((unused)))
{
#ifdef __cplusplus
#define _Static_assert static_assert
#endif
#ifdef __cplusplus
#undef _Static_assert
#endif
}

#endif /* __FENTRY_UNSUPP_FUNC_BPF_SKEL_H__ */
