/* SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause) */

/* THIS FILE IS AUTOGENERATED BY BPFTOOL! */
#ifndef __SIMPLE_OBJ_BPF_SKEL_H__
#define __SIMPLE_OBJ_BPF_SKEL_H__

#include <errno.h>
#include <stdlib.h>
#include <bpf/libbpf.h>

#define BPF_SKEL_SUPPORTS_MAP_AUTO_ATTACH 1

struct simple_obj_bpf {
	struct bpf_object_skeleton *skeleton;
	struct bpf_object *obj;
	struct {
		struct bpf_map *bss;
	} maps;
	struct {
		struct bpf_program *simple_prog;
	} progs;
	struct {
		struct bpf_link *simple_prog;
	} links;
	struct simple_obj_bpf__bss {
		int my_var;
	} *bss;

#ifdef __cplusplus
	static inline struct simple_obj_bpf *open(const struct bpf_object_open_opts *opts = nullptr);
	static inline struct simple_obj_bpf *open_and_load();
	static inline int load(struct simple_obj_bpf *skel);
	static inline int attach(struct simple_obj_bpf *skel);
	static inline void detach(struct simple_obj_bpf *skel);
	static inline void destroy(struct simple_obj_bpf *skel);
	static inline const void *elf_bytes(size_t *sz);
#endif /* __cplusplus */
};

static void
simple_obj_bpf__destroy(struct simple_obj_bpf *obj)
{
	if (!obj)
		return;
	if (obj->skeleton)
		bpf_object__destroy_skeleton(obj->skeleton);
	free(obj);
}

static inline int
simple_obj_bpf__create_skeleton(struct simple_obj_bpf *obj);

static inline struct simple_obj_bpf *
simple_obj_bpf__open_opts(const struct bpf_object_open_opts *opts)
{
	struct simple_obj_bpf *obj;
	int err;

	obj = (struct simple_obj_bpf *)calloc(1, sizeof(*obj));
	if (!obj) {
		errno = ENOMEM;
		return NULL;
	}

	err = simple_obj_bpf__create_skeleton(obj);
	if (err)
		goto err_out;

	err = bpf_object__open_skeleton(obj->skeleton, opts);
	if (err)
		goto err_out;

	return obj;
err_out:
	simple_obj_bpf__destroy(obj);
	errno = -err;
	return NULL;
}

static inline struct simple_obj_bpf *
simple_obj_bpf__open(void)
{
	return simple_obj_bpf__open_opts(NULL);
}

static inline int
simple_obj_bpf__load(struct simple_obj_bpf *obj)
{
	return bpf_object__load_skeleton(obj->skeleton);
}

static inline struct simple_obj_bpf *
simple_obj_bpf__open_and_load(void)
{
	struct simple_obj_bpf *obj;
	int err;

	obj = simple_obj_bpf__open();
	if (!obj)
		return NULL;
	err = simple_obj_bpf__load(obj);
	if (err) {
		simple_obj_bpf__destroy(obj);
		errno = -err;
		return NULL;
	}
	return obj;
}

static inline int
simple_obj_bpf__attach(struct simple_obj_bpf *obj)
{
	return bpf_object__attach_skeleton(obj->skeleton);
}

static inline void
simple_obj_bpf__detach(struct simple_obj_bpf *obj)
{
	bpf_object__detach_skeleton(obj->skeleton);
}

static inline const void *simple_obj_bpf__elf_bytes(size_t *sz);

static inline int
simple_obj_bpf__create_skeleton(struct simple_obj_bpf *obj)
{
	struct bpf_object_skeleton *s;
	struct bpf_map_skeleton *map __attribute__((unused));
	int err;

	s = (struct bpf_object_skeleton *)calloc(1, sizeof(*s));
	if (!s)	{
		err = -ENOMEM;
		goto err;
	}

	s->sz = sizeof(*s);
	s->name = "simple_obj_bpf";
	s->obj = &obj->obj;

	/* maps */
	s->map_cnt = 1;
	s->map_skel_sz = 24;
	s->maps = (struct bpf_map_skeleton *)calloc(s->map_cnt,
			sizeof(*s->maps) > 24 ? sizeof(*s->maps) : 24);
	if (!s->maps) {
		err = -ENOMEM;
		goto err;
	}

	map = (struct bpf_map_skeleton *)((char *)s->maps + 0 * s->map_skel_sz);
	map->name = "simple_o.bss";
	map->map = &obj->maps.bss;
	map->mmaped = (void **)&obj->bss;

	/* programs */
	s->prog_cnt = 1;
	s->prog_skel_sz = sizeof(*s->progs);
	s->progs = (struct bpf_prog_skeleton *)calloc(s->prog_cnt, s->prog_skel_sz);
	if (!s->progs) {
		err = -ENOMEM;
		goto err;
	}

	s->progs[0].name = "simple_prog";
	s->progs[0].prog = &obj->progs.simple_prog;
	s->progs[0].link = &obj->links.simple_prog;

	s->data = simple_obj_bpf__elf_bytes(&s->data_sz);

	obj->skeleton = s;
	return 0;
err:
	bpf_object__destroy_skeleton(s);
	return err;
}

static inline const void *simple_obj_bpf__elf_bytes(size_t *sz)
{
	static const char data[] __attribute__((__aligned__(8))) = "\
\x7f\x45\x4c\x46\x02\x02\x01\0\0\0\0\0\0\0\0\0\0\x01\0\xf7\0\0\0\x01\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x06\xc8\0\0\0\0\0\x40\0\0\0\0\0\x40\0\x09\0\
\x01\0\x2e\x73\x74\x72\x74\x61\x62\0\x2e\x73\x79\x6d\x74\x61\x62\0\x6b\x70\x72\
\x6f\x62\x65\0\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\x62\x73\x73\0\x73\x69\x6d\x70\
\x6c\x65\x5f\x6f\x62\x6a\x2e\x62\x70\x66\x2e\x63\0\x73\x69\x6d\x70\x6c\x65\x5f\
\x70\x72\x6f\x67\0\x6d\x79\x5f\x76\x61\x72\0\x4c\x49\x43\x45\x4e\x53\x45\0\x2e\
\x72\x65\x6c\x6b\x70\x72\x6f\x62\x65\0\x2e\x42\x54\x46\0\x2e\x42\x54\x46\x2e\
\x65\x78\x74\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\x25\x04\0\xff\xf1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x03\0\0\x03\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x36\x12\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x38\0\0\0\x42\x11\0\0\x05\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x04\0\0\0\x49\x11\0\0\
\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x04\x18\x10\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x61\
\x21\0\0\0\0\0\0\x04\x20\0\0\0\0\0\x01\x63\x12\0\0\0\0\0\0\xb4\0\0\0\0\0\0\0\
\x95\0\0\0\0\0\0\0\x42\x53\x44\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x04\0\0\0\x01\
\xeb\x9f\x01\0\0\0\0\x18\0\0\0\0\0\0\x03\0\0\0\x03\0\0\0\x01\xbd\0\0\0\0\x02\0\
\0\0\0\0\0\x02\0\0\0\x01\x04\0\0\x06\0\0\0\xc8\0\0\0\0\0\0\0\x03\0\0\0\0\0\0\0\
\x09\0\0\0\x06\0\0\x04\xc0\0\0\0\0\0\0\0\x0c\0\0\x05\0\0\0\0\x13\0\0\0\x06\0\0\
\x05\x80\0\0\0\x19\0\0\0\x06\0\0\x05\xc0\0\0\0\x1d\0\0\0\x06\0\0\x06\0\0\0\0\0\
\x05\0\0\x02\0\0\0\x98\0\0\0\x28\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\x05\0\0\0\0\0\
\0\0\x32\x08\0\0\0\0\0\0\x05\0\0\0\0\x04\0\0\x03\0\0\0\x98\0\0\0\x3f\0\0\0\x07\
\0\0\0\0\0\0\0\x44\0\0\0\x09\0\0\0\x40\0\0\0\x48\0\0\0\x0b\0\0\0\xc0\0\0\0\x4d\
\x01\0\0\0\0\0\0\x08\0\0\0\x40\0\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\x06\0\0\0\x08\0\
\0\0\x01\0\0\0\x5b\x01\0\0\0\0\0\0\x04\0\0\0\x20\0\0\0\x6f\x08\0\0\0\0\0\0\x0a\
\0\0\0\0\x04\0\0\x02\0\0\0\x10\0\0\0\x75\0\0\0\x06\0\0\0\0\0\0\0\x7a\0\0\0\x06\
\0\0\0\x40\0\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\x06\0\0\0\x08\0\0\0\x10\0\0\0\0\x05\
\0\0\x02\0\0\0\x10\0\0\0\0\0\0\0\x0d\0\0\0\0\0\0\0\x7f\0\0\0\x0f\0\0\0\0\0\0\0\
\0\x04\0\0\x03\0\0\0\x10\0\0\0\x88\0\0\0\x0e\0\0\0\0\0\0\0\x91\0\0\0\x0e\0\0\0\
\x20\0\0\0\x9a\0\0\0\x06\0\0\0\x40\0\0\0\xa8\x01\0\0\0\0\0\0\x04\0\0\0\x20\0\0\
\0\x7f\x84\0\0\x06\0\0\0\x0c\0\0\0\xb5\0\0\0\x10\0\0\0\0\0\0\0\xbb\0\0\0\x12\0\
\0\0\x20\0\0\0\xc3\0\0\0\x12\x01\0\0\x40\0\0\0\xce\0\0\0\x12\x01\0\0\x41\0\0\0\
\xdb\0\0\0\x12\x03\0\0\x42\0\0\0\xdf\0\0\0\x12\x03\0\0\x51\0\0\0\xe4\x84\0\0\
\x05\0\0\0\x04\0\0\0\xf2\0\0\0\x11\x08\0\0\0\0\0\0\xf8\0\0\0\x11\x01\0\0\x0c\0\
\0\0\xfa\0\0\0\x11\x02\0\0\x0d\0\0\0\xff\0\0\0\x11\x01\0\0\x0f\0\0\x01\x03\0\0\
\0\x11\x10\0\0\x10\0\0\x01\x0a\x08\0\0\0\0\0\0\x0e\0\0\x01\x10\x08\0\0\0\0\0\0\
\x11\0\0\0\0\x0d\0\0\x01\0\0\0\x14\0\0\x01\x14\0\0\0\x01\0\0\x01\x18\x01\0\0\0\
\0\0\0\x04\x01\0\0\x20\0\0\x01\x1c\x0c\0\0\x01\0\0\0\x13\0\0\x01\x28\x01\0\0\0\
\0\0\0\x01\x01\0\0\x08\0\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\x16\0\0\0\x08\0\0\0\x04\
\0\0\x01\x2d\x0e\0\0\0\0\0\0\x17\0\0\0\x01\0\0\x01\x35\x0e\0\0\0\0\0\0\x14\0\0\
\0\x01\0\0\x01\xa9\x0f\0\0\x01\0\0\0\x04\0\0\0\x18\0\0\0\0\0\0\0\x04\0\0\x01\
\xb1\x0f\0\0\x01\0\0\0\x04\0\0\0\x19\0\0\0\0\0\0\0\x04\0\x70\x74\x5f\x72\x65\
\x67\x73\0\x6f\x72\x69\x67\x5f\x67\x70\x72\x32\0\x66\x6c\x61\x67\x73\0\x63\x72\
\x31\0\x6c\x61\x73\x74\x5f\x62\x72\x65\x61\x6b\0\x75\x73\x65\x72\x5f\x72\x65\
\x67\x73\0\x75\x73\x65\x72\x5f\x70\x74\x5f\x72\x65\x67\x73\0\x61\x72\x67\x73\0\
\x70\x73\x77\0\x67\x70\x72\x73\0\x75\x6e\x73\x69\x67\x6e\x65\x64\x20\x6c\x6f\
\x6e\x67\0\x5f\x5f\x41\x52\x52\x41\x59\x5f\x53\x49\x5a\x45\x5f\x54\x59\x50\x45\
\x5f\x5f\0\x70\x73\x77\x5f\x74\0\x6d\x61\x73\x6b\0\x61\x64\x64\x72\0\x74\x70\
\x69\x5f\x69\x6e\x66\x6f\0\x69\x6e\x74\x5f\x63\x6f\x64\x65\0\x69\x6e\x74\x5f\
\x70\x61\x72\x6d\0\x69\x6e\x74\x5f\x70\x61\x72\x6d\x5f\x6c\x6f\x6e\x67\0\x75\
\x6e\x73\x69\x67\x6e\x65\x64\x20\x69\x6e\x74\0\x73\x63\x68\x69\x64\0\x69\x6e\
\x74\x70\x61\x72\x6d\0\x61\x64\x61\x70\x74\x65\x72\x5f\x49\x4f\0\x64\x69\x72\
\x65\x63\x74\x65\x64\x5f\x69\x72\x71\0\x69\x73\x63\0\x74\x79\x70\x65\0\x73\x75\
\x62\x63\x68\x61\x6e\x6e\x65\x6c\x5f\x69\x64\0\x63\x73\x73\x69\x64\0\x6d\0\x73\
\x73\x69\x64\0\x6f\x6e\x65\0\x73\x63\x68\x5f\x6e\x6f\0\x5f\x5f\x75\x33\x32\0\
\x75\x33\x32\0\x63\x74\x78\0\x69\x6e\x74\0\x73\x69\x6d\x70\x6c\x65\x5f\x70\x72\
\x6f\x67\0\x63\x68\x61\x72\0\x4c\x49\x43\x45\x4e\x53\x45\0\x6d\x79\x5f\x76\x61\
\x72\0\x2f\x62\x75\x69\x6c\x64\x64\x69\x72\x2f\x62\x75\x69\x6c\x64\x2f\x42\x55\
\x49\x4c\x44\x2f\x72\x65\x74\x73\x6e\x6f\x6f\x70\x2d\x30\x2e\x31\x30\x2e\x31\
\x2d\x62\x75\x69\x6c\x64\x2f\x72\x65\x74\x73\x6e\x6f\x6f\x70\x2d\x30\x2e\x31\
\x30\x2e\x31\x2f\x73\x72\x63\x2f\x74\x65\x73\x74\x73\x2f\x73\x69\x6d\x70\x6c\
\x65\x5f\x6f\x62\x6a\x2e\x62\x70\x66\x2e\x63\0\x09\x6d\x79\x5f\x76\x61\x72\x2b\
\x2b\x3b\0\x09\x72\x65\x74\x75\x72\x6e\x20\x30\x3b\0\x6c\x69\x63\x65\x6e\x73\
\x65\0\x2e\x62\x73\x73\0\x6b\x70\x72\x6f\x62\x65\0\0\0\0\xeb\x9f\x01\0\0\0\0\
\x20\0\0\0\0\0\0\0\x14\0\0\0\x14\0\0\0\x2c\0\0\0\x40\0\0\0\0\0\0\0\x08\0\0\x01\
\xb6\0\0\0\x01\0\0\0\0\0\0\0\x15\0\0\0\x10\0\0\x01\xb6\0\0\0\x02\0\0\0\0\0\0\
\x01\x3c\0\0\x01\x93\0\0\x34\x08\0\0\0\x28\0\0\x01\x3c\0\0\x01\x9e\0\0\x38\x02\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\x03\0\0\0\0\
\0\0\0\x20\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\0\0\x6a\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\x09\0\0\0\x02\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\xb0\0\0\0\0\0\0\0\x90\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\
\x08\0\0\0\0\0\0\0\x18\0\0\0\x11\0\0\0\x01\0\0\0\0\0\0\0\x06\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\x01\x40\0\0\0\0\0\0\0\x38\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\
\0\0\0\0\0\0\0\x18\0\0\0\x01\0\0\0\0\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\
\x78\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\
\x20\0\0\0\x08\0\0\0\0\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\x7c\0\0\0\0\0\
\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\x51\0\0\0\x09\
\0\0\0\0\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\x80\0\0\0\0\0\0\0\x10\0\0\0\
\x02\0\0\0\x03\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\x5c\0\0\0\x01\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\x90\0\0\0\0\0\0\x04\xd5\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\x61\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x06\x68\0\0\0\0\0\0\0\x60\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x08\0\0\0\0\0\0\0\0";

	*sz = sizeof(data) - 1;
	return (const void *)data;
}

#ifdef __cplusplus
struct simple_obj_bpf *simple_obj_bpf::open(const struct bpf_object_open_opts *opts) { return simple_obj_bpf__open_opts(opts); }
struct simple_obj_bpf *simple_obj_bpf::open_and_load() { return simple_obj_bpf__open_and_load(); }
int simple_obj_bpf::load(struct simple_obj_bpf *skel) { return simple_obj_bpf__load(skel); }
int simple_obj_bpf::attach(struct simple_obj_bpf *skel) { return simple_obj_bpf__attach(skel); }
void simple_obj_bpf::detach(struct simple_obj_bpf *skel) { simple_obj_bpf__detach(skel); }
void simple_obj_bpf::destroy(struct simple_obj_bpf *skel) { simple_obj_bpf__destroy(skel); }
const void *simple_obj_bpf::elf_bytes(size_t *sz) { return simple_obj_bpf__elf_bytes(sz); }
#endif /* __cplusplus */

__attribute__((unused)) static void
simple_obj_bpf__assert(struct simple_obj_bpf *s __attribute__((unused)))
{
#ifdef __cplusplus
#define _Static_assert static_assert
#endif
	_Static_assert(sizeof(s->bss->my_var) == 4, "unexpected size of 'my_var'");
#ifdef __cplusplus
#undef _Static_assert
#endif
}

#endif /* __SIMPLE_OBJ_BPF_SKEL_H__ */
